'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.uploadfile = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _uid = require('./uid');

var _uid2 = _interopRequireDefault(_uid);

var _request = require('./request');

var _request2 = _interopRequireDefault(_request);

var _extend = require('extend');

var _extend2 = _interopRequireDefault(_extend);

var _getThumb = require('./getThumb');

var _getThumb2 = _interopRequireDefault(_getThumb);

var _isLimit = require('./isLimit');

var _isLimit2 = _interopRequireDefault(_isLimit);

var _util = require('util.react');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// import props from "./props"
// import classNames from "classnames"


// import "./index.css"

var awaitFileLists = {};
var awaitFileUploadProps = {};

var uploadfile = function uploadfile(settings) {
    var uid = settings.id || '';
    var file = awaitFileLists[uid] || {};
    var props = awaitFileUploadProps[uid] || {};
    return (0, _request2.default)({
        action: props.action,
        file: file,
        data: props.data,
        headers: props.headers,
        onProgress: function onProgress(step) {
            settings.onProgress(step, file);
        },
        onSuccess: settings.onSuccess || function () {},
        onError: settings.onError || function (err, res) {
            settings.onError(err, res, file);
        },
        onXhrError: settings.onXhrError || function (e) {
            delete awaitFileLists[uid];
        }
    });
};

var AjaxUpload = function (_Component) {
    _inherits(AjaxUpload, _Component);

    function AjaxUpload(props) {
        _classCallCheck(this, AjaxUpload);

        var _this = _possibleConstructorReturn(this, (AjaxUpload.__proto__ || Object.getPrototypeOf(AjaxUpload)).call(this, props));

        _this.state = {
            uid: (0, _uid2.default)()
        };
        return _this;
    }

    _createClass(AjaxUpload, [{
        key: 'onChange',
        value: function onChange(fileData) {
            var self = this;
            var state = this.state;
            var props = this.props;

            var files = [];
            var errFilesLists = [];
            for (var i = 0; i < fileData.length; i++) {
                // 限制判断
                var limit_result = (0, _isLimit2.default)(fileData[i]);
                if (limit_result.type(props.allow)) {
                    errFilesLists.push({
                        file: fileData[i],
                        errType: 'TYPE'
                    });
                } else if (limit_result.size(props.size)) {
                    errFilesLists.push({
                        file: fileData[i],
                        errType: 'SIZE'
                    });
                }
                /* 文件夹的判断 不精确 && 当选择了上传文件夹是忽略此限制判断
                else if( limit_result.isFolder() ){
                    console.warn('\"'+fileData[i].name+'\" 是文件夹, 暂不支持上传文件夹 !')
                    errFilesLists.push({
                        file: fileData[i],
                        errType:'FOLDER'
                    })
                }*/
                else {
                        files[i] = fileData[i];
                        files[i].id = fileData[i].lastModified || fileData[i].lastModifiedDate.getTime() || (0, _uid2.default)();
                        files[i].thumb = (0, _getThumb2.default)({
                            defaultThumb: self.constructor.defaultProps.thumb,
                            thumbProps: self.props.thumb,
                            fileData: fileData[i]
                        });
                        awaitFileUploadProps[files[i].id] = {
                            action: props.action,
                            data: props.data,
                            headers: props.headers
                        };
                        awaitFileLists[files[i].id] = files[i];
                    }
            }
            // 有错误才抛出
            if (errFilesLists.length > 0) {
                self.props.onError(errFilesLists);
            }

            // 去除 files 中 undefined项
            var filesArray = [];
            for (var _i = 0; _i < files.length; _i++) {
                if (typeof files[_i] !== 'undefined') {
                    filesArray.push((0, _extend2.default)(true, {}, files[_i]));
                }
            }
            // 有正确可上传文件才抛出
            if (fileData.length != errFilesLists.length) {
                self.props.onPick(filesArray);
            }
            // 相同文件重复触发
            self.$refs[self.props.prefixClassName + '-xhr-input-' + self.state.uid].value = '';
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.toggleWebkitDirectory();
        }
        // react 不支持webkit属性 只能以这种方式添加

    }, {
        key: 'toggleWebkitDirectory',
        value: function toggleWebkitDirectory() {
            var self = this;
            // console.log('toggleWebkitDirectory',self.props)
            if (self.$refs[self.props.prefixClassName + '-xhr-input-' + self.state.uid]) {
                if (self.props.webkitdirectory) {
                    self.$refs[self.props.prefixClassName + '-xhr-input-' + self.state.uid].setAttribute('webkitdirectory', true);
                } else {
                    self.$refs[self.props.prefixClassName + '-xhr-input-' + self.state.uid].removeAttribute('webkitdirectory');
                }
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var self = this;
            var ref = _util2.default.ref(this);
            var pcls = self.props.prefixClassName;

            // 拖拽
            var dropPropsFn = {};
            if (self.props.drop) {
                dropPropsFn = {
                    onDragOver: function onDragOver(e) {
                        // 这保证 handleDroZoneDrop 可以被调用
                        e.preventDefault();
                    },
                    onDrop: function onDrop(e) {
                        e.preventDefault();
                        // 拖拽暂时只支持文件 ,拖拽文件夹提示不支持 (limit.js中做)
                        self.onChange(e.dataTransfer.files);
                    }
                };
            }
            // if(self.props.webkitdirectory){
            //     self.toggleWebkitDirectory()
            // }
            return require("react").createElement(
                'span',
                { className: pcls + '-xhr' },
                require("react").createElement('input', {
                    ref: ref(pcls + '-xhr-input-' + self.state.uid),
                    type: 'file',
                    className: pcls + '-xhr-input',
                    multiple: self.props.multiple,
                    onChange: function onChange(e) {
                        self.onChange(e.target.files);
                    }
                }),
                require("react").createElement(
                    'label',
                    _extends({}, dropPropsFn, {
                        className: pcls + '-xhr-label',
                        onClick: function onClick() {
                            self.$refs[pcls + '-xhr-input-' + self.state.uid].click();
                        }
                    }),
                    self.props.children
                )
            );
        }
    }]);

    return AjaxUpload;
}(_react.Component);

require('./props').default(AjaxUpload);
exports.uploadfile = uploadfile;
exports.default = AjaxUpload;