'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = getThumb;

var _extend = require('extend');

var _extend2 = _interopRequireDefault(_extend);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// TODO: 整个js整改 defaultprops props ->  extend
function getThumb(settings) {
	settings = settings || {};
	// 获取文件格式大类
	var fileType = 'unknown'; // 文件大类
	fileType = settings.fileData.type.split('/')[0] || fileType;
	// console.log('fileType : ',fileType)
	// 文件后缀名
	var fileFormat = '';
	fileFormat = settings.fileData.name.replace(/.+\/([^\/]+)$/, '$1');
	fileFormat = fileFormat.substr(fileFormat.lastIndexOf(".") == -1 ? fileFormat.length : fileFormat.lastIndexOf(".")).substr(1).toLowerCase() || 'default';
	// console.log('fileFormat : ',fileFormat)

	var thumb = false;

	// priority 1
	if (window.URL && fileType == 'image' && fileFormat != 'psd') {
		// 清除释放
		window.URL.revokeObjectURL(settings.fileData);
		thumb = window.URL.createObjectURL(settings.fileData) || false;
		return thumb;
	}

	// priority 2
	if (thumb === false) {
		// 获取文件格式
		var config = (0, _extend2.default)(true, settings.defaultThumb, settings.thumbProps);
		return config[fileType][fileFormat] || config[fileType].default;
	}

	return thumb || '';
} /**
   * priority
   * 1. create an object URL for a File, Blob, or MediaStream object
   * 2. file format configuration
   *
   *
   * Assign the project to an settings.
   * @param {object} settings - xxx
   * @param {object} settings.defaultThumb - 组件默认配置
   * @param {object} settings.thumbProps - 用户设置的默认配置
   * @param {object} settings.fileData - 当前上传文件
   *
   */