'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.uploadfileProps = undefined;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var example = function example() {
    return arguments;
};

var UploadPickerProps = function UploadPickerProps(app) {
    var _text;

    app.defaultProps = {
        prefixClassName: 'face-upload',
        allow: [],
        // type:'file', // 默认属性不抛出
        multiple: false, // IE不支持
        webkitdirectory: false, // ie11- safari不支持
        onPick: function onPick(files) {},
        onError: function onError(errFiles) {},
        breakresume: false, // 断点续传
        themes: 'default',
        drop: false, // ie10-不支持,默认拖拽功能关闭
        thumb: { //缩略图默认配置
            image: {
                default: '/lib/images/image.png', // 通用图片文件格式缩略图
                "bmp": "", "gif": "", "ico": "", "jpg": "", "jpeg": "", "tif": "", "ani": "", "ans": "", "cdr": "", "dib": "", "dwg": "", "dxb": "", "dxf": "", "emf": "", "eps": "", "flc": "", "icm": "", "mac": "", "mag": "", "svg": ""
            },
            music: {
                default: '/lib/images/music.png', // 通用音乐文件格式缩略图
                "mid": "", "midi": "", "mp3": "", "wav": "", "aif": "", "aifc": "", "aiff": "", "au": "", "cmf": "", "idf": "", "rmi": "", "snd": "", "svx": ""
            },
            video: {
                default: '/lib/images/video.png', // 通用视频文件格式缩略图
                "avi": "", "mov": "", "mpg": "", "mpeg": "", "rmvb": "", "rm": "", "swf": "", "asf": "", "asx": "", "dat": ""
            },
            application: {
                default: '/lib/images/package.png', // 通用压缩包文件格式缩略图
                "cab": "", "img": "", "iso": "", "rar": "", "zip": "", "arc": "", "arj": "", "bfc": "", "lzh": "", "rle": ""
            },
            text: (_text = {
                default: '/lib/images/file.png', // 通用文件格式缩略图
                "asp": "", "bak": "", "bat": "", "bin": "", "cfg": "", "cgi": "", "chk": "", "chm": "", "cmd": "", "com": "", "dat": "", "dbf": "", "dll": "", "htm": "", "html": "", "doc": "", "dot": "", "drv": "", "eml": "", "exe": "", "fon": "", "hlp": "", "inf": "", "ini": "", "jar": "", "log": "", "msg": "", "msi": "", "ocx": "", "pdf": "", "php": "", "ppt": "", "reg": "", "sys": "", "ttf": "", "txt": "", "rtf": "", "xls": "", "xlt": "", "aca": "", "acf": "", "acm": "" }, _defineProperty(_text, 'asp', ""), _defineProperty(_text, "bbs", ""), _defineProperty(_text, 'bin', ""), _defineProperty(_text, "c", ""), _defineProperty(_text, "cal", ""), _defineProperty(_text, "cdf", ""), _defineProperty(_text, "cdx", ""), _defineProperty(_text, 'cfg', ""), _defineProperty(_text, 'chm', ""), _defineProperty(_text, "clp", ""), _defineProperty(_text, "cnf", ""), _defineProperty(_text, "cnt", ""), _defineProperty(_text, "col", ""), _defineProperty(_text, "cpl", ""), _defineProperty(_text, "cpp", ""), _defineProperty(_text, "crd", ""), _defineProperty(_text, "crt", ""), _defineProperty(_text, "cur", ""), _defineProperty(_text, "css", ""), _defineProperty(_text, 'dat', ""), _defineProperty(_text, 'dbf', ""), _defineProperty(_text, "dcx", ""), _defineProperty(_text, "ddi", ""), _defineProperty(_text, "dev", ""), _defineProperty(_text, "dir", ""), _defineProperty(_text, 'dll', ""), _defineProperty(_text, "dos", ""), _defineProperty(_text, "der", ""), _defineProperty(_text, "dic", ""), _defineProperty(_text, "err", ""), _defineProperty(_text, "exp", ""), _defineProperty(_text, "exc", ""), _defineProperty(_text, "fp", ""), _defineProperty(_text, "fnd", ""), _defineProperty(_text, "for", ""), _defineProperty(_text, "fot", ""), _defineProperty(_text, "fpt", ""), _defineProperty(_text, "frt", ""), _defineProperty(_text, "frx", ""), _defineProperty(_text, "fxp", ""), _defineProperty(_text, "grh", ""), _defineProperty(_text, "goc", ""), _defineProperty(_text, "gra", ""), _defineProperty(_text, "h", ""), _defineProperty(_text, 'hlp', ""), _defineProperty(_text, "hqx", ""), _defineProperty(_text, "ht", ""), _defineProperty(_text, 'htm', ""), _defineProperty(_text, "idx", ""), _defineProperty(_text, "iff", ""), _defineProperty(_text, "ime", ""), _defineProperty(_text, "inc", ""), _defineProperty(_text, 'inf', ""), _defineProperty(_text, "lnk", ""), _defineProperty(_text, "mdb", ""), _defineProperty(_text, "men", ""), _defineProperty(_text, 'rtf', ""), _defineProperty(_text, "sav", ""), _defineProperty(_text, "scp", ""), _defineProperty(_text, "scr", ""), _defineProperty(_text, "sct", ""), _defineProperty(_text, "scx", ""), _defineProperty(_text, "set", ""), _defineProperty(_text, "shb", ""), _defineProperty(_text, "sql", ""), _defineProperty(_text, "swg", ""), _defineProperty(_text, 'sys', ""), _text),
            unknown: {
                default: '/lib/images/unknown.png' // 通用未知文件格式缩略图
            }
        }
    };
    app.propTypes = {
        prefixClassName: _propTypes2.default.string,
        themes: _propTypes2.default.string,
        drop: _propTypes2.default.bool,
        allow: _propTypes2.default.array,
        size: _propTypes2.default.number,
        // type:p.string,
        multiple: _propTypes2.default.bool,
        onPick: _propTypes2.default.func,
        onError: _propTypes2.default.func,
        data: _propTypes2.default.object, // 提交时附带数据
        headers: _propTypes2.default.object,
        thumb: _propTypes2.default.object, // 缩略图配置
        withCredentials: _propTypes2.default.bool // ajax upload with cookie send (default:false)
    };
    app.propExample = {
        allow: example(['.jpg', '.png', '.gif']),
        size: example(1024, 5),
        thumb: example({
            image: {
                default: 'http://xxxxxx.jpg',
                png: 'http://xxxxxx.jpg'
            },
            vedio: {
                default: 'http://xxxxxx.gif'
            }
        }, {
            image: 'http://xxxxxx.jpg'
        })
    };
    app.propsDesc = {};
};
var uploadfileProps = function uploadfileProps(app) {
    app.defaultProps = {};
    app.propTypes = {
        id: _propTypes2.default.string,
        onProgress: _propTypes2.default.func,
        onSuccess: _propTypes2.default.func,
        onError: _propTypes2.default.func,
        onXhrError: _propTypes2.default.func
    };
    app.propExample = {
        onProgress: example(function (step, file) {}),
        onSuccess: example(function (res) {}),
        onError: example(function (err, res) {}),
        onXhrError: example(function (e) {})
    };
    app.propsDesc = {};
};

exports.uploadfileProps = uploadfileProps;
exports.default = UploadPickerProps;